### Hierarchy

- NavigationService
  - WindowService

## Index

### Constructors

- constructor

### Properties

- app
- screen
- alertWindow

### Accessors

- currentTarget
- location
- title

### Methods

- alert
- back
- closePopup
- confirm
- getHostForElement
- navigate
- notify
- openPage
- openWindow
- refresh
- refreshScreen
- register
- registerForPopup
- registerHostForWindow
- registerNavigationHook
- remove

## Constructors

### constructor

- new WindowService(app: App, jsonService: JsonService): WindowService

- Overrides NavigationService.constructor

  - Defined in src/web/services/WindowService.ts:102

  #### Parameters

  - ##### app: App

  - ##### jsonService: JsonService

  #### Returns WindowService

## Properties

### app

app: App

Inherited from NavigationService.app

- Defined in src/services/NavigationService.ts:70

### screen

screen: IScreen

- Defined in src/web/services/WindowService.ts:36

### Static alertWindow

alertWindow: AtomAlertWindow = AtomAlertWindow

- Defined in src/web/services/WindowService.ts:34

This is just to preload Alert window.

## Accessors

### currentTarget

- get currentTarget(): HTMLElement
- set currentTarget(v: HTMLElement): void

- - Defined in src/web/services/WindowService.ts:39

  #### Returns HTMLElement

- - Defined in src/web/services/WindowService.ts:43

  #### Parameters

  - ##### v: HTMLElement

  #### Returns void

### location

- get location(): AtomUri
- set location(v: AtomUri): void

- Overrides NavigationService.location

  - Defined in src/web/services/WindowService.ts:96

  Gets current location of browser, this does not return actual location but it returns values of browser location. This is done to provide mocking behavior for unit testing.

  readonly
  type

    {AtomLocation}

  memberof

    BrowserService

  #### Returns AtomUri

- Overrides NavigationService.location

  - Defined in src/web/services/WindowService.ts:100

  Gets current location of browser, this does not return actual location but it returns values of browser location. This is done to provide mocking behavior for unit testing.

  #### Parameters

  - ##### v: AtomUri

  #### Returns void

### title

- get title(): string
- set title(v: string): void

- Overrides NavigationService.title

  - Defined in src/web/services/WindowService.ts:75

  Get current window title

  type

    {string}

  memberof

    BrowserService

  #### Returns string

- Overrides NavigationService.title

  - Defined in src/web/services/WindowService.ts:83

  Set current window title

  memberof

    BrowserService

  #### Parameters

  - ##### v: string

  #### Returns void

## Methods

### alert

- alert(message: string | FormattedString | any, title?: string): Promise<any>

- Overrides NavigationService.alert

  - Defined in src/web/services/WindowService.ts:182

  #### Parameters

  - ##### message: string | FormattedString | any

  - ##### Optional title: string

  #### Returns Promise<any>

### back

- back(): void

- Overrides NavigationService.back

  - Defined in src/web/services/WindowService.ts:165

  #### Returns void

### closePopup

- closePopup(e: MouseEvent): void

- - Defined in src/web/services/WindowService.ts:202

  #### Parameters

  - ##### e: MouseEvent

  #### Returns void

### confirm

- confirm(message: string | FormattedString, title: string): Promise<any>

- Overrides NavigationService.confirm

  - Defined in src/web/services/WindowService.ts:173

  #### Parameters

  - ##### message: string | FormattedString

  - ##### title: string

  #### Returns Promise<any>

### getHostForElement

- getHostForElement(): HTMLElement

- - Defined in src/web/services/WindowService.ts:257

  #### Returns HTMLElement

### navigate

- navigate(url: string): void

- Overrides NavigationService.navigate

  - Defined in src/web/services/WindowService.ts:161

  Navigate current browser to given url.

  memberof

    BrowserService

  #### Parameters

  - ##### url: string

  #### Returns void

### notify

- notify(message: string | FormattedString, title?: string, type?: NotifyType, delay?: number): void

- Overrides NavigationService.notify

  - Defined in src/web/services/WindowService.ts:279

  #### Parameters

  - ##### message: string | FormattedString

  - ##### Optional title: string

  - ##### Optional type: NotifyType

  - ##### Optional delay: number

  #### Returns void

### openPage

- openPage<T>(pageName: string | any, p?: INameValuePairs, options?: IPageOptions): Promise<T>

- Inherited from NavigationService.openPage

  - Defined in src/services/NavigationService.ts:83

  #### Type parameters

  - #### T

  #### Parameters

  - ##### pageName: string | any

    url

  - ##### Optional p: INameValuePairs

    parameters

  - ##### Optional options: IPageOptions

  #### Returns Promise<T>

### Protected openWindow

- openWindow<T>(url: AtomUri, options?: IPageOptions): Promise<T>

- Overrides NavigationService.openWindow

  - Defined in src/web/services/WindowService.ts:301

  #### Type parameters

  - #### T

  #### Parameters

  - ##### url: AtomUri

  - ##### Optional options: IPageOptions

  #### Returns Promise<T>

### refresh

- refresh(): void

- Overrides NavigationService.refresh

  - Defined in src/web/services/WindowService.ts:253

  #### Returns void

### refreshScreen

- refreshScreen(): void

- - Defined in src/web/services/WindowService.ts:271

  #### Returns void

### register

- register(id: string, type: IClassOf<AtomControl>): void

- - Defined in src/web/services/WindowService.ts:169

  #### Parameters

  - ##### id: string

  - ##### type: IClassOf<AtomControl>

  #### Returns void

### Protected registerForPopup

- registerForPopup(): void

- - Defined in src/web/services/WindowService.ts:292

  #### Returns void

### registerHostForWindow

- registerHostForWindow(f: HostForElementFunc): IDisposable

- - Defined in src/web/services/WindowService.ts:147

  #### Parameters

  - ##### f: HostForElementFunc

  #### Returns IDisposable

### registerNavigationHook

- registerNavigationHook(callback: navigateCallback): IDisposable

- Inherited from NavigationService.registerNavigationHook

  - Defined in src/services/NavigationService.ts:174

  #### Parameters

  - ##### callback: navigateCallback

  #### Returns IDisposable

### remove

- remove(view: object, force?: boolean): Promise<boolean>

- Inherited from NavigationService.remove

  - Defined in src/services/NavigationService.ts:160

  Sends signal to remove window/popup/frame, it will not immediately remove, because it will identify whether it can remove or not by displaying cancellation warning. Only if there is no cancellation warning or user chooses to force close, it will not remove.

  #### Parameters

  - ##### view: object

  - ##### Optional force: boolean

  #### Returns Promise<boolean>

  true if view was removed successfully

Generated using TypeDoc